class Output {

  constructor() {
    this.abapCode = `
***************************************************************
* This code was generated by openapi-json-to-abap
***************************************************************
    DATA: ls_meta TYPE /weco/ws_oai_meta,
    ls_metapath TYPE /weco/ws_oai_metapath,
    ls_metareqbody TYPE /weco/ws_oai_metareqbody,
    ls_metaprop TYPE /weco/ws_oai_metaprop,
    ls_metaparam TYPE /weco/ws_oai_metaparam.    
    `;

    this.pathStatement = `
    CLEAR: ls_metapath.
    ls_metapath-path = '{{path}}'.
    ls_metapath-meth = '{{method}}'.
    ls_metapath-oprid = '{{operationId}}'.
    ls_metapath-struci = '{{wecoRequest}}'.
    ls_metapath-struco = '{{wecoResponse}}'.
    ls_metapath-secur = '{{security}}'.
    `;
    
    this.parameterStatement = `
    CLEAR: ls_metaparam.
    ls_metaparam-name = '{{name}}'.
    ls_metaparam-parin = '{{inSegment}}'.
    ls_metaparam-flreq = '{{required}}'.
    ls_metaparam-type = '{{type}}'.
    APPEND ls_metaparam TO ls_metapath-param.
    `;
    
    this.requestBodyStatement = `
    CLEAR: ls_metareqbody.
    ls_metareqbody-flreq = '{{required}}'.
    ls_metareqbody-ctype = '{{contentType}}'.
    `;
    
    this.requestBodyPropertyStatement = `
    CLEAR: ls_metaprop.
    ls_metaprop-name = '{{name}}'.
    ls_metaprop-flreq = '{{required}}'.
    ls_metaprop-type = '{{type}}'.
    APPEND ls_metaprop TO ls_metareqbody-propr.
    `;
  }

  finishPath() {
    var s = `
    APPEND ls_metapath TO rs_meta-path.\n`;

    this.appendStatement(s);
  }

  finishRequestBody() {
    var s = `
    ls_metapath-reqbo = ls_metareqbody.\n`;
    this.appendStatement(s);
  }

  addPath(path, method, operationId, wecoRequest, wecoResponse, security) {
    var s = this.pathStatement;
    s = s.replace('{{path}}', path);
    s = s.replace('{{method}}', method);
    s = s.replace('{{operationId}}', operationId);
    s = s.replace('{{wecoRequest}}', wecoRequest);
    s = s.replace('{{wecoResponse}}', wecoResponse);
    s = s.replace('{{security}}', security === undefined ? '' : security);
    this.appendStatement(s);
  }

  addParameter(name, inSegment, required, type) {
    var s = this.parameterStatement;
    s = s.replace('{{name}}', name);
    s = s.replace('{{inSegment}}', inSegment);
    s = s.replace('{{required}}', required ? 'X' : '');
    s = s.replace('{{type}}', type);
    this.appendStatement(s);    
  }

  addRequestBody(required, contentType) {
    var s = this.requestBodyStatement;
    s = s.replace('{{required}}', required ? 'X' : '');
    s = s.replace('{{contentType}}', contentType);
    this.appendStatement(s);     
  }

  addRequestBodyProperty(name, type, required) {
    var s = this.requestBodyPropertyStatement;
    s = s.replace('{{name}}', name);
    s = s.replace('{{type}}', type);
    s = s.replace('{{required}}', required ? 'X' : '');
    this.appendStatement(s);
  }

  appendStatement(statement) {
    this.abapCode += statement;
  }

  getAbapCode() {
    var finalCode = `method GET_META_RAW.
    `
    + this.abapCode +
    `endmethod.`;

    return finalCode;
  }

}

module.exports = Output;